<?php
// $Id: pages.inc,v 1.1.2.2 2010/12/21 00:22:55 tomdude48 Exp $

// $obj can be a node object, nid or path
function linkintel_node_edit_fieldset($obj, $context = 'page') {
  if(is_object($obj)) {
    $node = $obj;
    $pid = $node->nid;
  }
  else {
    $pid = $obj;
  }
  if($pid) {
    $settings = linkintel_load_page_settings($pid);
  }
  else if ($node->type) {
    $settings = linkintel_load_page_settings(NULL, $node->type);
  }
  else {
    return array();
  }
  $form['linkintel'] = array(
    '#type' => 'fieldset',
    '#title' => t('Link Intelligence'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
    '#attributes' => array('class' => 'linkintel'),
  );
  $options = linkintel_get_priority_options();
  $form['linkintel']['linkintel_priority'] = array(
    '#type' => 'select',
    '#title' => ($node) ? t('Node priority') : t('Page priority'), 
    '#options' => $options,
    '#default_value' => (isset($settings->priority)) ? $settings->priority : variable_get('linkintel_type_'. $node->type .'_priority', variable_get('linkintel_priority', LINKINTEL_PRIORITY_DEFAULT)),
    '#description' => t('Use to set how nodes of this content type are. The higher the priority, the more likely they will be backlinked to. If unsure, just set to "Standard".'),
  );
  
  $form['linkintel']['autogen'] = array(
    '#type' => 'fieldset',
    '#title' => t('Link autogen settings'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
    '#attributes' => array('class' => 'linkintel-autogen'),
  ); 
  $form['linkintel']['autogen'] = array_merge($form['linkintel']['autogen'], linkintel_get_autogen_subform($settings, $context)); 

  $form['linkintel']['sync'] = array(
    '#type' => 'fieldset',
    '#title' => t('Request sync settings'),
    '#collapsible' => TRUE,
    '#collapsed' => TRUE,
    '#attributes' => array('class' => 'linkintel-sync'),
  ); 
  $form['linkintel']['sync'] = array_merge($form['linkintel']['sync'], linkintel_get_request_sync_subform($settings, $context));

  return $form;
}

function linkintel_page_settings_edit_page() {
  drupal_set_title(t('Edit page settings'));
  $pn = linkintel_construct_pathnid_obj($_GET['pid']);
  $output .= drupal_get_form('linkintel_page_settings_edit_form', $pn);
  return $output;
}

function linkintel_page_settings_edit_form($form_state, $pn) {
  if($pn->nid || $pn->path) {
    if($pn->nid) {
      $node = node_load($pn->nid);
    }
    $link = linkintel_l_report($pn);
    $form['page'] = array(
        '#title' => t('Page'),
        '#type' => 'item',
        '#value' =>  $link,
    );
    $form['nid'] = array(
      '#type' => 'value',
      '#value' => $pn->nid
    );
    $form['path'] = array(
      '#type' => 'value',
      '#value' => ($pn->path) ? $pn->path : 'node/' . $pn->nid
    );
  }
  else {
    $form['path'] = array(
      '#type' => 'textfield',
      '#title' => t('URL Path'),
      '#required' => TRUE,
      '#description' => t('Enter the url path of the page. This can be an internal Drupal path such as node/add or an external URL such as http://drupal.org. Enter &lt;front&gt; to link to the front page.'),
    );   
  }
  $fieldset = linkintel_node_edit_fieldset(($node) ? $node : $pid);
  $form = array_merge($form, $fieldset['linkintel']);
  $form['autogen']['#collapsed'] = FALSE;
  $form['sync']['#collapsed'] = FALSE;
  
  
  $form['save'] = array(
    '#type' => 'submit',
    '#value' => t('Submit'),
  );
  
  return $form;
}

/**
 * Validates the page keyword edit form
 * 
 * @param $form
 * @param $form_state
 */
function linkintel_page_settings_edit_form_validate($form, &$form_state) {
  $link = $form_state['values']['path'];  
  linkintel_parse_link_path($link, $msgs, 'form');
}

function linkintel_page_settings_edit_form_submit($form, &$form_state) {
//dsm($form_state);
  $settings = new stdClass();
  $settings->nid = $form_state['values']['nid'];
  $settings->path = $form_state['values']['path'];
  $settings->priority = $form_state['values']['linkintel_priority'];
  $settings->content_autogen = $form_state['values']['linkintel_content_autogen'];
  $settings->content_target_count = $form_state['values']['linkintel_content_target_count'];
  $settings->sidebar_autogen = $form_state['values']['linkintel_sidebar_autogen'];
  $settings->sidebar_target_count = $form_state['values']['linkintel_sidebar_target_count'];
  $settings->autogen_exclusivity = $form_state['values']['autogen_exclusivity'];
  $settings->request_sync_title = $form_state['values']['linkintel_request_sync_title'];
  $settings->request_sync_tax = $form_state['values']['linkintel_request_sync_tax'];    
  linkintel_save_page_settings($settings);
}